program drip;
// 2007 - engenic.com - Vern Baker
// Directory RIP
// A console application for building files for WiX

{ PARAMETERS

[x]  [-S StartDir relative path]

}


{$APPTYPE CONSOLE}


uses
  windows,
  SysUtils,
  Classes,
  Registry,
  DOSCommand,
  FileWorkUnit,
  CalcWorkUnit;

type

  TByteArray = array [0..0] of byte;

const

  // This is stand alone program
  cEmbedded = False;

// -- Note, this is a chunk shared with the TFSentinel program
// ---------INCLUDE FILE-----------------------------------------
// -- Included inside TFSentinel
// -- Included inside TFCleanLogs
// --
const
   // Application information
   appName               = 'drip';
   appVersion            = '0.01';

   // Types (commands)
   cMaxDays              = 'MaxDays';
   cMinGB                = 'MinGB';

   // Defaults
   cValMaxDays           = 14;
   cValMinGB             = 2;


   // Parameter
   cColFCode             = 1;
   cColFVal              = 2;

   // Delimiter
   cD                    = '~';

var

   s1                    : String;
   s2                    : String;
   mError                : String;
   mLoop                 : Integer;
   mRecCount             : Integer;

   //
   mDate                 : String;
   mMaxDays              : Integer;
   mMinGB                : Integer;

   //
   mSupress              : Boolean;
   mHeadingDisplayed     : Boolean;
   mShowHelp             : Boolean;
   mContinue             : Boolean;

   mDrive                : String;
   mLogFile              : String;
   mFreeMB               : Integer;
   mLogDirectory         : String;

   // Read in the parameters
   mParmArray            : array [1..200, 1..4] of String;  // For paramters .. see cCol??? values
   mFCode                : String;
   mFVal                 : String;

   // Scan for files
   mFileList             : TStringList;
   mFileName             : String;
   mCountLogs            : Integer;
   mCountDirs            : Integer;

   mDosCommand           : TDosCommand;
   mLines                : TStringList;

   /////////////////////////////////////
   procedure DisplayHeading;
   begin
        if not mSupress then
        begin
             mHeadingDisplayed := True;

             writeln(appName);
             writeln('(c) 2007 engenic - Version '+appVersion+' ');
             // Put your name above etc.
             writeln('Parameter = Starting Directory for rip.  Current if blank');
             writeln(' ');
             writeln(' ');
             writeln(' ');

        end;
   end; // DisplayHeading


   // Output to writeln
   procedure Output(pLine: String);
   begin
        // Console mode only...
        writeln(pLine);
   end; // Output


   // Read the TeleFlow Registry
   function FindDriveSpaceFreeMB(pDrive: String): Integer;
   var
      // Gather data
      mLoop           : Integer;
      mDrive          : String;
      mDriveList      : String;
      mNumDrive       : Integer;
      mFree           : Integer;
      //mSize           : Integer;
      //mPercent        : Integer;
   begin
        result := -1;
        // Drive space
        ////////////////
        try
           mDriveList    := UpperCase(Copy(pDrive,1,1)); //GetLocalHardDrives;
           for mLoop := 1 to length(mDriveList) do
           begin
                mDrive := Copy(mDriveList,mLoop,1);
                if (mDrive >= 'A') and (mDrive <= 'Z') then
                begin
                     mNumDrive := Pos(mDrive,'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
                     //mSize     := Round(DiskSize(mNumDrive) / (1024 * 1024));
                     mFree     := Round(DiskFree(mNumDrive) / (1024 * 1024));

                     //mResult := mResult + mDrive + ':' + IntToStr(mFree) + ' MB   ';
                     //mPercent  := Round(mFree / mSize * 100);

                     // Get the MB
                     result    := Round(mFree);
                end;
           end; // drivespace
        except
        end;
   end;



///////////////////////////////////////////
///////////////////////////////////////////
// PROGRAM BEGINS HERE
///////////////////////////////////////////
///////////////////////////////////////////

begin
  mLines      := TStringList.Create;
  mDosCommand := TDosCommand.Create(nil);
  try
        DisplayHeading;

        mDrive  := Copy(ParamStr(1),1,1);
        if mDrive = '' then
        begin
             mDrive := 'C';
        end;


        mDosCommand.OutputLines := mLines;
        mDosCommand.CommandLine := 'dir';
        mDosCommand.Execute;
        mDosCommand.SendLine('dir', True);

        for mLoop := 0 to 5 do
        begin
             sleep(100);
        end;



        for mLoop := 0 to mLines.Count -1 do
        begin
             output('Got here');
             output(mLines[mLoop]);
        end;

        // Determine if we need to delete more to save ensure we have a min GB level
        (*
        mFreeMB := FindDriveSpaceFreeMB(mDrive);
        Output('MB free space at:    ' + IntToStr(mFreeMB));

        // Cycle
        mLogFile :=  mDrive+':\zerofile.txt';
        Output('Writing: '+mLogFile);

        while mFreeMB > 10 do  //10
        begin
             for mLoop := 0 to 300 do
             begin
                  LogFileOutput(mLogFile, ' '
                  );
             end;
             mFreeMB := FindDriveSpaceFreeMB(mDrive);
             Output('MB free space at:    ' + IntToStr(mFreeMB));
        end;
         *)
     //////////////////////
     // Clean up
     //////////////////////
         //    deletefile(mLogFile);
         //    Output('Deleted:     ' +mLogFile);

     //////////////////////
     // Exit
     //////////////////////

     // Set exit code to report errors
          Output('Done.');

  finally
     mDosCommand.Free;
     mLines.Free
  end
// ---------INCLUDE FIL

end.




